c======================================================================|
      subroutine model(idf,ro,pr,vx,vz,gm,margin,x,ix,z,jx)
c======================================================================|
      implicit real*8 (a-h,o-z)
c----------------------------------------------------------------------|
      dimension x(ix),dxm(ix)
      dimension z(jx),dzm(jx)
      dimension ro(ix,jx),pr(ix,jx),vx(ix,jx)
      dimension vz(ix,jx)

c----------------------------------------------------------------------|
c   parameters
c----------------------------------------------------------------------|
      gm=5./3.

c----------------------------------------------------------------------|
c   grid
c----------------------------------------------------------------------|

      dx0=7.5/real(ix-margin*2+1)
      do i=1,ix
         dxm(i)=dx0
      enddo
       
      izero=margin
      x(izero)=-0.500001d0*dx0
      do i=izero+1,ix
         x(i) = x(i-1)+dxm(i-1)
      enddo
      do i=izero-1,1,-1
         x(i) = x(i+1)-dxm(i)
      enddo

      dz0=30./real(jx-margin*2+1)
      do j=1,jx
         dzm(j)=dz0
      enddo
       
      jzero=margin+1
      z(jzero)=0.
      do j=jzero+1,jx
         z(j) = z(j-1)+dzm(j-1)
      enddo
      do j=jzero-1,1,-1
         z(j) = z(j+1)-dzm(j)
      enddo

c----------------------------------------------------------------------|
c     store initial condition into common area
c----------------------------------------------------------------------|

      do j=1,jx
      do i=1,ix
         ro(i,j) = 1.
         vx(i,j) = 0.0
         vz(i,j) = 0.0
         pr(i,j) = 1/gm
      enddo
      enddo
c----------------------------------------------------------------------|
c     write parameters to file
c----------------------------------------------------------------------|
c                                                     netcdf - start >>>
      call ncputos(idf,'gm',gm)
c                                                     netcdf - end   <<<

      
      return
      end
