c======================================================================|
      subroutine model(idf,ro,pr,vx,vy,gm,margin,x,ix,y,jx)
c======================================================================|
      implicit real*8 (a-h,o-z)
      dimension x(ix),dxm(ix)
      dimension y(jx),dym(jx)
      dimension ro(ix,jx),pr(ix,jx),vx(ix,jx)
      dimension vy(ix,jx)

c----------------------------------------------------------------------|
c   parameters
c----------------------------------------------------------------------|
      gm=5./3.

c----------------------------------------------------------------------|
c   grid
c----------------------------------------------------------------------|


      pi1=      acos(-1.0d0)
      pi2= 2.d0*acos(-1.0d0)

      dx0=pi2/real(ix-margin*2+1)
      do i=1,ix
         dxm(i)=dx0
      enddo
       
      izero=ix/2+1
      x(izero)=0.
      do i=izero+1,ix
         x(i) = x(i-1)+dxm(i-1)
      enddo
      do i=izero-1,1,-1
         x(i) = x(i+1)-dxm(i)
      enddo


      dy0=pi2/real(jx-margin*2+1)
      do j=1,jx
         dym(j)=dy0
      enddo
       
      jzero=jx/2+1
      y(jzero)=0.
      do j=jzero+1,jx
         y(j) = y(j-1)+dym(j-1)
      enddo
      do j=jzero-1,1,-1
         y(j) = y(j+1)-dym(j)
      enddo

c----------------------------------------------------------------------|
c     store initial condition into common area
c----------------------------------------------------------------------|
      open(unit=1,file='para.txt')
      read(1,100) ro2
      read(1,100) u1
      read(1,100) u2
      read(1,100) wkx
 100  FORMAT((G13.6))
      close(unit=1)

      ro1=1.0
c      ro2=0.25
c      u1=0.
c      u2=0.5
      pr1=1.0/gm
      pr2=1.0/gm
      wtr=0.05
c      wkx=2.0

      do j=1,jx
      do i=1,ix
         ro(i,j)=ro1+(ro2-ro1)*(1+tanh(y(j)/wtr))/2
         pr(i,j)=pr1+(pr2-pr1)*(1+tanh(y(j)/wtr))/2
         vx(i,j)=u1+(u2-u1)*(1+tanh(y(j)/wtr))/2
         vy(i,j)=0.d0
      enddo
      enddo

c----------------------------------------------------------------------|
c     perturbation
c----------------------------------------------------------------------|

      amp=1.d-1

      if (.false.) then
      mdum=-1
      do j=1,jx
      do i=1,ix
         rannum=2.d0*ran2(mdum)-1.
         vy(i,j) = amp*rannum
      enddo
      enddo

      else

      alpha1=ro1/(ro1+ro2)
      alpha2=ro2/(ro1+ro2)

      omegar=wkx*(alpha1*u1+alpha2*u2)
      omegai=sqrt(wkx*wkx*alpha1*alpha2*(u1-u2)*(u1-u2))

      do j=1,jx
      do i=1,ix
       if (y(j).lt.0) then
         vre=amp*exp(wkx*y(j))*((wkx*u1-omegar)*cos(wkx*x(i))+
     &        omegai*sin(wkx*x(i)))
         vim=amp*exp(wkx*y(j))*((wkx*u1-omegar)*sin(wkx*x(i))-
     &        omegai*cos(wkx*x(i)))
         vy(i,j)=vy(i,j)+vre
         vx(i,j)=vx(i,j)-vim
         pr(i,j)=pr(i,j)
     &         -ro(i,j)/wkx*(omegai*vre-(wkx*u1-omegar)*vim)
       else
         vre=amp*exp(-wkx*y(j))*((wkx*u2-omegar)*cos(wkx*x(i))
     &        +omegai*sin(wkx*x(i)))
         vim=amp*exp(-wkx*y(j))*((wkx*u2-omegar)*sin(wkx*x(i))
     &        -omegai*cos(wkx*x(i)))
         vy(i,j)=vy(i,j)+vre
         vx(i,j)=vx(i,j)+vim
         pr(i,j)=pr(i,j)
     &        +ro(i,j)/wkx*(omegai*vre-(wkx*u2-omegar)*vim)
        endif
      enddo
      enddo

      endif


c----------------------------------------------------------------------|
c     write parameters to file
c----------------------------------------------------------------------|
c                                                     netcdf - start >>>
      call ncputos(idf,'gm',gm)
      call ncputos(idf,'ro1',ro1)
      call ncputos(idf,'pr1',pr1)
      call ncputos(idf,'vx0',vx0)
      call ncputos(idf,'vx1',vx1)
c                                                     netcdf - end   <<<

      
      return
      end
