c======================================================================|
      subroutine model(idf,ro,pr,vx,vy,gm,gx,gxm,gy,gym,
     &     margin,x,ix,y,jx)
c======================================================================|
      implicit real*8 (a-h,o-z)
c----------------------------------------------------------------------|
      dimension x(ix),dxm(ix)
      dimension y(jx),dym(jx)
      dimension ro(ix,jx),pr(ix,jx),vx(ix,jx)
      dimension vy(ix,jx)
      dimension gx(ix,jx),gy(ix,jx)
      dimension gxm(ix,jx),gym(ix,jx)
      dimension gymz(jx),roz(jx),prz(jx)

c----------------------------------------------------------------------|
c   parameters
c----------------------------------------------------------------------|
      pi = acos(-1.0d0)
      gm=5./3.

c----------------------------------------------------------------------|
c   grid
c----------------------------------------------------------------------|

      dx0=pi*2.d0/(ix-margin*2)
      do i=1,ix
         dxm(i)=dx0
      enddo
       
      izero=ix/2+1
      x(izero)=0.
      do i=izero+1,ix
        x(i) = x(i-1)+dxm(i-1)
      enddo
      do i=izero-1,1,-1
        x(i) = x(i+1)-dxm(i)
      enddo


      dy0=pi*2.d0/(jx-margin*2-1)
      do j=1,jx
         dym(j)=dy0
      enddo
       
      jzero=jx/2+1
      y(jzero)=0.
      do j=jzero+1,jx
         y(j) = y(j-1)+dym(j-1)
      enddo
      do j=jzero-1,1,-1
         y(j) = y(j+1)-dym(j)
      enddo
c----------------------------------------------------------------------|
c     gravitation
c----------------------------------------------------------------------|
      g0= -1.0d0/gm

      do j=1,jx
        gymz(j)=g0
      enddo

      do j=1,jx
      do i=1,ix
         gx(i,j)=0.0
         gxm(i,j)=0.0
         gy(i,j)=g0
         gym(i,j)=g0
      enddo
      enddo

c----------------------------------------------------------------------|
c     initial condition 
c----------------------------------------------------------------------|
      open(unit=1,file='para.txt')
      read(1,100) ro1
      read(1,100) wkx
 100  FORMAT((G13.6))
      close(unit=1)

c      ro1=0.25d0
      ro0=1.00d0

      pr0=ro0/gm
      prz(jx)=pr0
      do j=jx-1,1,-1
         if (y(j).le.0) then
           roz(j)=ro1
         else
           roz(j)=ro0
         endif
         prz(j)=prz(j+1)-roz(j)*gymz(j)*dym(j)
      enddo

      do i=1,ix
      do j=1,jx
         ro(i,j)=roz(j)
         pr(i,j)=prz(j)
         vx(i,j)=0.d0
         vy(i,j)=0.d0
      enddo
      enddo

c----------------------------------------------------------------------|
c     perturbation
c----------------------------------------------------------------------|
      amp=0.01

      if (.false.) then
      mdum=-1
      do j=1,jx
      do i=1,ix
         rannum=2.d0*ran2(mdum)-1.
         vy(i,j) = amp*rannum
      enddo
      enddo

      else

c      wkx=2.0
      omegai=sqrt(g0*wkx*(ro1-ro0)/(ro1+ro0))
c     write(6,*) 'omegai=',omegai
c
      do j=1,jx
      do i=1,ix
         if (y(j).le.0) then
           vv0=amp*exp(wkx*y(j))*omegai
           vx(i,j)= vv0*cos(wkx*x(i))
           vy(i,j)= vv0*sin(wkx*x(i))
           ro(i,j)=ro(i,j)*(1.d0+omegai*vy(i,j)/g0)
         else
           vv0=amp*exp(-wkx*y(j))*omegai
           vx(i,j)=-vv0*cos(wkx*x(i))
           vy(i,j)= vv0*sin(wkx*x(i))
           ro(i,j)=ro(i,j)*(1.d0+omegai*vy(i,j)/g0)
         endif
      enddo
      enddo

      endif

c----------------------------------------------------------------------|
c     write parameters to file
c----------------------------------------------------------------------|
c                                                     netcdf - start >>>
      call ncputos(idf,'gm',gm)
      call ncputos(idf,'ro1',ro1)
c                                                     netcdf - end   <<<

      
      return
      end
