//
//
//
//
//
package jp.ac.chiba_u.astro.adapter;

import org.apache.log4j.Category;
import org.apache.log4j.Priority;

import jp.co.kgt.i3.task.application.ApplicationAdapter;
import jp.co.kgt.i3.task.application.ApplicationEventListener;
import jp.co.kgt.i3.task.application.ApplicationEvent;

import java.util.Hashtable;
import java.util.Enumeration;
import java.lang.StringBuffer;
import java.util.Vector;
import java.util.Enumeration;
import java.lang.Process;
import java.io.IOException;
import java.io.File;
import java.io.FileOutputStream;
import java.io.FileInputStream;
import java.io.InputStream;
import java.io.BufferedReader;
import java.io.InputStreamReader;

/**
 * @description An adapter for Command Execution Adapter
 * @author H.Asakura
 */
public class CmdExecAdapter implements ApplicationAdapter {

    /** ApplicationEventListener list */
    transient private Vector listeners = new Vector();

    /** command name */
    //InputStream avsFileStream  = null;
    Hashtable ht               = null;
    String sp                  = File.separator;
    String workDir             = null;
    String jobWorkDirPath      = null;
    String avsFilePath         = null;
    String stdoutFile          = null;
    String cmdStatus           = null;
    String avsFile             = null;
    int jobid;

    /** exit status */
    int status;

    public CmdExecAdapter() {
    }

    public void addApplicationEventListener(ApplicationEventListener l) {
        listeners.addElement(l);
    }

    public void removeApplicationEventListener(ApplicationEventListener l) {
        listeners.removeElement(l);
    }

    private void fireApplicationExited(Object source, int exitValue) {
        fireApplicationExited(
            new ApplicationEvent(source, exitValue));
    }

    private void fireApplicationExited(ApplicationEvent event) {
        if (listeners.size() > 0) {
            Vector targets;
            synchronized(this) {
                targets = (Vector)listeners.clone();
            }
            for (Enumeration target = targets.elements();
                 target.hasMoreElements(); ) {
                ApplicationEventListener listener;
                listener = (ApplicationEventListener)target.nextElement();
                listener.applicationExited(event);
            }
        }
    }

    // ApplicationAdapter method: //
    public Boolean isStreaming() { return Boolean.FALSE; }

    public String getApplicationName() {
        return "CmdExecAdapter";
    }

    public void start() throws IOException {
       Enumeration e = null;

       String command = (String)ht.get("command.name");
       Vector pl      = (Vector)ht.get("param.list");
       Hashtable pt   = (Hashtable)ht.get("param");

       jobWorkDirPath = workDir+sp+String.valueOf(jobid);
       File file = new File(jobWorkDirPath);
       file.mkdirs();

       StringBuffer sb = new StringBuffer();
       for (int i=0; i<pl.size(); i++) {
	  String value = (String)pt.get((String)pl.get(i));
	  sb.append(" ");
	  sb.append(value);
       }

       //
       //avsFilePath = workDir+sp+String.valueOf(jobid)+sp+avsFile;
System.out.println("========workDir:"+workDir);
System.out.println("========jobid:"+jobid);
       avsFilePath = workDir+sp+String.valueOf(jobid);
System.out.println("========avsFilePath:"+avsFilePath);
       command = command + " " + avsFilePath + sb.toString();

       try {
          Runtime runtime = Runtime.getRuntime();

          // for PC
          //Process process = runtime.exec(command);
	  //System.out.println("adapter command:"+command);
          // for Unix
          Process process = runtime.exec("sh "+command);
	  System.out.println("adapter command:"+command);

          BufferedReader from = new BufferedReader(new InputStreamReader(process.getInputStream()));

          String line = null;
          String stdoutMessages = "";

          while((line = from.readLine()) != null) {
	     stdoutMessages += line + "\n";
          }
          from.close();
          process.waitFor();
          status = process.exitValue();

          cmdStatus = stdoutMessages;

          String stdoutPath = workDir+sp+String.valueOf(jobid)+sp+stdoutFile;
          FileOutputStream fos = new FileOutputStream(stdoutPath);
	  fos.write(stdoutMessages.getBytes());
	  fos.close();

          //
          //avsFileStream = new FileInputStream(avsFilePath);

          fireApplicationExited(this, status);

       } catch (InterruptedException ie) {
          System.err.println("exception " + ie);
       } catch (IOException ioe) {
          System.err.println("Exception " + ioe.getMessage());
          throw ioe;
       }
    }

    // Setter method
    public void  setCommandParam(Hashtable ht){
       this.ht = ht;
    }

    public void setJobId(Integer JobId){
       this.jobid = JobId.intValue();
    }

    public void setWorkDir(String workDir){
       this.workDir = workDir;
    }

    public void setStdoutFile(String stdoutFile){
       this.stdoutFile = stdoutFile;
    }

    public void setAvsFile(String avsFile){
       this.avsFile = avsFile;
    }

    // Getter method
    public String getCmdStatus(){
       return cmdStatus;
    }

    public String getJobWorkDirPath(){
       return jobWorkDirPath;
    }

    public String getAvsFilePath(){
       return avsFilePath;
    }

    // 
    //public InputStream getAvsFileStream(){
    //   return avsFileStream;
    //}
}
