/*
====================================================================
=
=
=
=
=
====================================================================
*/
package jp.ac.chiba_u.astro.ui;

import jp.co.kgt.i3.config.ConfigManagerIfc;
import jp.co.kgt.i3.ui.ConfigManager;

import java.io.File;

import org.apache.log4j.Category;

/**
WVSVXeRtBO[V擾NX
 * @author KGT Inc.
 * @version 1.0
 * @since 2002.2
*/
public class NetlabConfigManager {
   static Category log = Category.getInstance(NetlabConfigManager.class.getName());

   private static final String sp           = File.separator;
   private static NetlabConfigManager instance    = null;

   private static String contextPath        = null;
   private static String configPath         = null;
   private static String templatePath       = null;
   private static String vTemplatePath      = null;
   private static String vtlVTemplatePath   = null;

   /** RXgN^ */
   public NetlabConfigManager() {
      synchronized(NetlabConfigManager.class) {
         setConfigPath();
      }
   }

   /** RtBO[VpX̐ݒ */
   private void setConfigPath() {
      ConfigManagerIfc cm = ConfigManager.getInstance();
      String contextPath = cm.getString("ContextPath", ".");
      if (contextPath.endsWith(sp))
         contextPath = contextPath.substring(0, contextPath.length()-1);

      this.contextPath      = contextPath;
      this.configPath       = contextPath + sp + "WEB-INF" + sp + "conf";
      this.templatePath     = contextPath + sp + "templates";
      this.vTemplatePath    = contextPath + sp + "vtemplates";
      String vtlPath = contextPath.substring(contextPath.lastIndexOf(sp)+1, contextPath.length());
      this.vtlVTemplatePath = vtlPath + sp + "vtemplates";
   }

   /** ReLXgpX̎擾 */
   public String getContextPath() {
      return this.contextPath;
   }

   /** RtBO[VpX̎擾 */
   public String getConfigPath() {
      return this.configPath;
   }

   /** evCgpX̎擾 */
   public String getTemplatePath() {
      return this.templatePath;
   }

   /** uevCgpX̎擾 */
   public String getVTemplatePath() {
      return this.vTemplatePath;
   }

   /** uevCgpuskpX̎擾 */
   public String getVTLVTemplatePath() {
      return this.vtlVTemplatePath;
   }

   public static synchronized NetlabConfigManager getInstance() {
      if (instance == null) {
         instance = new NetlabConfigManager();
      }
      return instance;
   }
}
