/*
====================================================================
=
=
=
=
=
====================================================================
*/
package jp.ac.chiba_u.astro.ui;

import jp.ac.chiba_u.astro.ui.NetlabConfigManager;

import jp.co.kgt.i3.config.ConfigReader;

import org.xml.sax.SAXException;
import org.apache.log4j.Category;

import java.util.Map;
import java.util.List;
import java.util.Iterator;
import java.util.HashMap;
import java.util.ArrayList;
import java.io.File;
import java.io.PrintStream;
import java.io.IOException;

/**
 *
 * @author KGT Inc.
 * @version 1.0
 * @since 2002.2
*/
public class NetlabConfigReader {
   static Category log = Category.getInstance(NetlabConfigReader.class.getName());

   private static final String sp = File.separator;
   private static final String CONFIG_FILE = "netlab_config.xml";

   private static NetlabConfigReader instance = null;
   private static Map paramMap = new HashMap();
   private static boolean initialized = false;
   private static ConfigReader config = null;
   private static String configPath = null;

   /** RXgN^ */
   public NetlabConfigReader() {
      synchronized(NetlabConfigReader.class) {
         readData();
      }
   }

   /** ēǂݍ݂s */
   public void setReload(boolean reload) {
      initialized = !reload;
      config = null;
   }

   /** RtBO[VEt@C̃Zbg(netlab_config.xml) */
   public void setConfigFile(String file) {
      this.configPath = file;
   }

   /** RtBO[VEt@CpX̎擾(netlab_config.xml) */
   private String getConfigFile() {
      if (configPath == null) {
         NetlabConfigManager cm = NetlabConfigManager.getInstance();
         configPath = cm.getConfigPath();
         configPath = configPath + sp + CONFIG_FILE;
      }
      return configPath;
   }

   /** RtBO[VEt@C̓ǂݍ */
   protected void readData() {
      if (!initialized) {
         if (config == null) {
            try {
               config = new ConfigReader(getConfigFile());
               paramMap.putAll(config.getParameters());
               initialized = true;
            } catch (IOException ioe) {
               log.error("IOException :"+ioe);
            } catch (SAXException saxe) {
               log.error("SAXException :"+saxe);
            }
         }
      }
   }

   /** RtBO[VEt@C̃p[^lǂݍ */
   public String getConfigParameter(String paramName) {
      if (paramMap.containsKey(paramName)) {
         String value = (String)paramMap.get(paramName);
	 value.trim();
	 if (value != null && !value.equals("")) {
            return value;
	 } else {
            return null; 
	 }
      } else { 
         return null; 
      }
   }

   public static synchronized NetlabConfigReader getInstance() {
      if (instance == null) {
         instance = new NetlabConfigReader();
      }
      return instance;
   }
}
