/*
====================================================================
= 
=
=
=
=
====================================================================
*/

package jp.ac.chiba_u.astro.ui.screens;

import jp.ac.chiba_u.astro.ui.NetlabConfigManager;
import jp.ac.chiba_u.astro.ui.NetlabConfigReader;
import jp.ac.chiba_u.astro.ui.SessionParamIO;
import jp.ac.chiba_u.astro.ui.UserManager;

import jp.co.kgt.i3.ui.RunData;
import jp.co.kgt.i3.ui.VelocityScreen;
import jp.co.kgt.i3.auth.User;

import org.apache.velocity.VelocityContext;
import org.apache.log4j.Category;

import java.io.File;
import java.util.HashMap;

/**
 * 
 * 
 * 
 */
public class Viz000 extends VelocityScreen {
    static Category log = Category.getInstance(Viz000.class.getName());
    RunData data            = null;
    VelocityContext context = null;
    HashMap hm              = null;
    String sp               = File.separator;
    String account          = null;
    String password         = null;

    protected void doBuildTemplate(RunData data, VelocityContext context) {
       this.data    = data;
       this.context = context;

       if (!getPageParam())
          if (data.getUser() == null)
             redirect("login", data);

       if (!loginUser())
          redirect("login", data);

       readSystemConfig();
    }

    /** y[Wp[^̎擾 */
    private boolean getPageParam() {
       account = data.getParameter("account");
       if (account == null)
          return false;
       password = data.getParameter("password");
       if (password == null)
          return false;
       return true;
    }

    /** [UF؏ */
    private boolean loginUser() {
        boolean state = true;
        User user = null;

        if (account != null) {
            UserManager um = new UserManager(data);
            user = um.loginUser(account, password);
        } else {
            UserManager um = new UserManager(data);
            user = um.checkUser();
        }
        if (user == null) {
            state = false;
            log.error("ZbVؒfꂽ[U݂܂B");
        }
        return state;
    }

    /** VXeRtBO[V̎擾 */
    protected void readSystemConfig() {
       hm = new HashMap();
       NetlabConfigManager ncm = NetlabConfigManager.getInstance();
       String configPath = ncm.getConfigPath();
       String vTemplatePath = ncm.getVTLVTemplatePath();

       NetlabConfigReader ncr = NetlabConfigReader.getInstance();
       String command_config_file = configPath + sp + ncr.getConfigParameter("command.list.file");
       String viz_script_config_file = configPath + sp + ncr.getConfigParameter("viz.script.config.file");
       hm.put("command.config.file", command_config_file);
       hm.put("viz.script.config.file", viz_script_config_file);
       hm.put("vtemplate.path", vTemplatePath);

       String cmdapplname = ncr.getConfigParameter("cmd.application.name");
       String cmdtaskname = ncr.getConfigParameter("cmd.task.name");
       hm.put("cmd.application.name", cmdapplname);
       hm.put("cmd.task.name", cmdtaskname);

       String avs_input_file_name = ncr.getConfigParameter("avs.input.file.name");
       String avs_output_file_name = ncr.getConfigParameter("avs.output.file.name");
       String avsapplname = ncr.getConfigParameter("avs.application.name");
       String avstaskname = ncr.getConfigParameter("avs.task.name");
       hm.put("avs.application.name", avsapplname);
       hm.put("avs.task.name", avstaskname);
       hm.put("avs.input.file.name", avs_input_file_name);
       hm.put("avs.output.file.name", avs_output_file_name);

       String refresh_interval = ncr.getConfigParameter("system.page.refresh.interval");
       String num_pooling = ncr.getConfigParameter("system.num.pooling");
       String max_pooling = ncr.getConfigParameter("system.max.pooling");
       String work_path = ncr.getConfigParameter("system.work.path");
       hm.put("system.page.refresh.interval", new Integer(refresh_interval));
       hm.put("system.num.pooling", new Integer(num_pooling));
       hm.put("system.max.pooling", new Integer(max_pooling));
       hm.put("system.work.path", work_path);

       SessionParamIO spio = new SessionParamIO(data); 
       spio.setSessionParam("system.param", hm);
    }
}
