/*
====================================================================
=
=
=
=
=
====================================================================
*/

package jp.ac.chiba_u.astro.ui.screens;

import jp.ac.chiba_u.astro.etc.OutputPageParam;
import jp.ac.chiba_u.astro.ui.SessionParamIO;
import jp.ac.chiba_u.astro.xml.CommandConfigParser;

import jp.co.kgt.i3.ui.RunData;
import jp.co.kgt.i3.ui.VelocityScreen;

import org.apache.velocity.VelocityContext;
import org.apache.log4j.Category;

import java.util.Vector;
import java.util.Hashtable;
import java.util.HashMap;
import java.util.Enumeration;

/**
 * 
 * 
 */
public class Viz101 extends VelocityScreen {
    static Category log = Category.getInstance(Viz101.class.getName());
    RunData data               = null;
    VelocityContext context    = null; 
    String command_config_file = null;
    Hashtable command_list     = null;
    HashMap hm                 = null;

    protected void doBuildTemplate(RunData data, VelocityContext context) {
       this.data    = data;
       this.context = context;

       getSessionParam();
       readCommandConfig();
       putPageParam();
       setSessionParam();
    }

    protected void getSessionParam() {
       SessionParamIO spio = new SessionParamIO(data);
       hm = spio.getSessionParam("system.param");
       this.command_config_file = (String)hm.get("command.config.file");
    }

    protected void setSessionParam() {
       SessionParamIO spio = new SessionParamIO(data);
       hm.put("command.list", command_list);
       spio.setSessionParam("system.param", hm);
    }

    protected void readCommandConfig() {
       CommandConfigParser ccp = new CommandConfigParser(command_config_file);
       this.command_list = ccp.getConfig();
    }

    protected void putPageParam() {
       Enumeration e = null;
       Vector cmdList = new Vector();

       for (e = command_list.keys(); e.hasMoreElements();) {
          String keyname = (String)e.nextElement();
	  if (keyname.indexOf(".list") == -1)
	     cmdList.add(keyname);
       }

       OutputPageParam viz101 = new OutputPageParam();       
       viz101.set("command.list", cmdList);
       context.put("viz101", viz101);
    }
}
