/*
====================================================================
= 
=
=
=
====================================================================
*/

package jp.ac.chiba_u.astro.ui.screens;

import jp.ac.chiba_u.astro.etc.OutputPageParam;
import jp.ac.chiba_u.astro.ui.SessionParamIO;

import jp.co.kgt.i3.ui.RunData;
import jp.co.kgt.i3.ui.VelocityScreen;
import jp.co.kgt.i3.auth.User;
import jp.co.kgt.i3.task.job.Job;
import jp.co.kgt.i3.task.job.JobManager;
import jp.co.kgt.i3.task.job.JobStatus;

import org.apache.velocity.VelocityContext;
import org.apache.log4j.Category;

import java.util.Vector;
import java.util.Hashtable;
import java.util.HashMap;
import java.util.Enumeration;

/**
 * 
 * 
 */
public class Viz103 extends VelocityScreen {
    static Category log = Category.getInstance(Viz103.class.getName());
    RunData data               = null;
    VelocityContext context    = null;
    User user                  = null;
    String select_command_name = null;
    Hashtable command_list     = null;
    HashMap hm                 = null;
    String job_no              = null;
    String taskname            = null;
    String applname            = null;
    String work_path           = null;

    protected void doBuildTemplate(RunData data, VelocityContext context) {
       this.data    = data;
       this.context = context;

       getSessionParam();
       getPageParam();

       if (execJob())
          putPageParam();

       setSessionParam();
    }

    /** ZbVp[^̎擾 */
    protected void getSessionParam() {
       SessionParamIO spio = new SessionParamIO(data);
       hm = spio.getSessionParam("system.param");
       this.command_list = (Hashtable)hm.get("command.list");
       this.select_command_name = (String)hm.get("select.command.name");
       this.applname = (String)hm.get("cmd.application.name");
       this.taskname = (String)hm.get("cmd.task.name");
       this.work_path = (String)hm.get("system.work.path");
    }

    /** ZbVp[^̐ݒ */
    protected void setSessionParam() {
       SessionParamIO spio = new SessionParamIO(data);
       spio.setSessionParam("system.param", hm);
    }

    /** Wu̎s */
    protected boolean execJob() {
       boolean state   = true;
       Job job         = null;
       User user       = null;

       user = data.getUser(); 

       Hashtable ht = new Hashtable();
       Hashtable pt = (Hashtable)command_list.get(select_command_name);
       Vector pl = (Vector)command_list.get(select_command_name+".list");

       ht.put("command.name",select_command_name);
       ht.put("param.list",pl);
       ht.put("param",pt);

       // Job̐
       try {
          job = new Job(user, taskname);
	  job_no = Integer.toString(job.getId());
       } catch(Exception e) {
          log.error("jobł܂łB");
	  state = false;
	  return state;
       }

       // Job̃`FbN
       if(job == null) {
          log.error("jobĂ܂B");
	  state = false;
	  return state;
       }

       JobManager jm = JobManager.getInstance();
       // p[^ZbgJob̎s
       try {
 	  jm.setParameter(job.getId(), applname, "workDir", work_path);
 	  jm.setParameter(job.getId(), applname, "commandParam", ht);
 	  jm.setParameter(job.getId(), applname, "jobId", new Integer(job.getId()));
	  jm.submitJob(user, job);
       } catch(Exception e) {
          log.error("Jobsł܂łB");
	  state = false;
	  return state;
       }

       return state;
    }

    /** Oy[Wp[^̎擾 */
    protected void getPageParam() {
       Enumeration e = null;

       Hashtable pt = (Hashtable)command_list.get(select_command_name);

       for (e = pt.keys(); e.hasMoreElements();) {
          String param_name = (String)e.nextElement();
          String value = data.getParameter(param_name);
	  pt.put(param_name, value);
       }

       command_list.put(select_command_name, pt);
    }

    /** Viz103y[Wo */
    protected void putPageParam() {
       Enumeration e = null;

       Hashtable pt = (Hashtable)command_list.get(select_command_name);
       Vector param_list = (Vector)command_list.get(select_command_name+".list");

       for(int i=0; i<param_list.size(); i++){
          System.out.println("@"+param_list.get(i));
       }

       OutputPageParam viz103 = new OutputPageParam();       
       viz103.set("select.command.name", select_command_name);
       viz103.set("job.no", job_no);
       viz103.set("param.list", param_list);
       viz103.set("value.list", pt);
       context.put("viz103", viz103);
    }
}
