/*
====================================================================
= 
=
=
=
=
====================================================================
*/

package jp.ac.chiba_u.astro.ui.screens;

import jp.ac.chiba_u.astro.etc.OutputPageParam;
import jp.ac.chiba_u.astro.ui.SessionParamIO;
import jp.ac.chiba_u.astro.ui.VTemplateMapper;

import jp.co.kgt.i3.ui.RunData;
import jp.co.kgt.i3.ui.VelocityScreen;
import jp.co.kgt.i3.auth.User;
import jp.co.kgt.i3.task.job.Job;
import jp.co.kgt.i3.task.job.JobManager;
import jp.co.kgt.i3.task.job.JobStatus;

import org.apache.velocity.VelocityContext;
import org.apache.log4j.Category;

import java.io.File;
import java.io.FileOutputStream;
import java.io.InputStream;
import java.io.IOException;
import java.util.Vector;
import java.util.Hashtable;
import java.util.HashMap;

/**
 * 
 * 
 */
public class Viz303 extends VelocityScreen {
    static Category log = Category.getInstance(Viz303.class.getName());
    String sp                   = File.separator;
    RunData data                = null;
    VelocityContext context     = null;
    User user                   = null;
    Hashtable viz_list          = null;
    HashMap hm                  = null;
    String v_code               = null;
    String taskname             = null;
    String applname             = null;
    String cmd_applname         = null;
    String vTemplatePath        = null;
    String avsFilePath          = null;
    String work_path            = null;
    String avs_output_file_name = null;
    String select_viz_name      = null;
    String job_no               = null;
    int avs_job_status          = 0;
    int refresh_interval        = 0;
    int retry                   = 0; 
    int max_retry               = 0; 
 
    protected void doBuildTemplate(RunData data, VelocityContext context) {
       this.data = data;
       this.context = context;

       getSessionParam();

       switch(avs_job_status) {
          case 0:
                 getPageParam();
                 execJob();
                 putPageParam_Exec();
                 break;
          case 1:
                 checkJob();
                 putPageParam_Check();
                 break;
          case 2:
                 putPageParam_View();
                 break;
       }

       setSessionParam();

    }


    /** åѥ᡼μ */
    protected void getSessionParam() {
       SessionParamIO spio = new SessionParamIO(data);
       hm = spio.getSessionParam("system.param");
       this.viz_list = (Hashtable)hm.get("viz.list");
       this.job_no = ((Integer)hm.get("cmd.jobid")).toString();
       this.cmd_applname = (String)hm.get("cmd.application.name");
       this.applname = (String)hm.get("avs.application.name");
       this.taskname = (String)hm.get("avs.task.name");
       this.vTemplatePath = (String)hm.get("vtemplate.path");
       this.avs_job_status = ((Integer)hm.get("avs.job.status")).intValue();
       this.work_path = (String)hm.get("system.work.path");
       this.avs_output_file_name = (String)hm.get("avs.output.file.name");
    }

    /** åѥ᡼ */
    protected void setSessionParam() {
       SessionParamIO spio = new SessionParamIO(data);
       spio.setSessionParam("system.param", hm);
    }

    /** ڡѥ᡼μ */
    protected void getPageParam() {
       select_viz_name = (String)hm.get("select.viz.name");
       Hashtable pt = (Hashtable)viz_list.get(select_viz_name);
       Vector pl = (Vector)viz_list.get(select_viz_name+".list");

       for(int i=0; i<pl.size(); i++) {
          String param_name = (String)pl.get(i);
          String value = data.getParameter(param_name);
          pt.put(param_name, value);
       }

       viz_list.put(select_viz_name, pt);
    }

    /** ֤μ¹ */
    protected boolean execJob() {
       boolean state   = true;
       Job job         = null;
       User user       = null;

       user = data.getUser();

       Hashtable ht = new Hashtable();
       Hashtable pt = (Hashtable)viz_list.get(select_viz_name);
       String vTemplate = (String)pt.get("v_template");
       Vector pl = (Vector)viz_list.get(select_viz_name+".list");

       for(int i=0; i<pl.size(); i++) {
          String param_name = (String)pl.get(i);
          String value = (String)pt.get(param_name);
          ht.put(param_name, value);
       }
       JobManager jm = JobManager.getInstance();

log.debug("=============job_no:"+job_no);
log.debug("=============cmd_applname:"+cmd_applname);
       avsFilePath = (String)jm.getParameter(Integer.parseInt(job_no), cmd_applname, "avsFilePath");

log.debug("=============avsFilePath:"+avsFilePath);
log.debug("=============ht:"+ht);

       ht.put("filename", avsFilePath);

       vTemplatePath = vTemplatePath + sp + vTemplate;
       VTemplateMapper vtm = new VTemplateMapper();
       v_code = vtm.doMapping(vTemplatePath, ht);

       // Job
       try {
          job = new Job(user, taskname);
          job_no = Integer.toString(job.getId());
       } catch(Exception e) {
          log.error("can't generate job");
          state = false;
          return state;
       }

       // JobΥå
       if(job == null) {
          log.error("job is null");
          state = false;
          return state;
       }

       // ѥ᡼åȤJobμ¹
       try {
          jm.setParameter(job.getId(), applname, "code", v_code);
          jm.submitJob(user, job);
          hm.put("avs.job.status", new Integer(1));
          hm.put("avs.jobid", new Integer(job.getId()));
       } catch(Exception e) {
          log.error("can't exec job");
          state = false;
          return state;
       }

       return state;
    }

   protected void checkJob() {
      int jobid = ((Integer)hm.get("avs.jobid")).intValue();
      JobManager jm = JobManager.getInstance();
      JobStatus jstat = jm.getJobStatus(jobid); 
      String statmsg = jstat.getStatusMessage();
     
      InputStream rin = null;
      if (statmsg.equals("FINISHED")) {
         // @==Job OK

         rin = (InputStream)jm.getParameter(jobid, applname, "outputStream");

         String wdir = work_path + sp + ((Integer)hm.get("cmd.jobid")).toString();

         File file = new File(wdir, avs_output_file_name);

         if ( file.exists() ) {
            file.delete();
         }
         if ( rin != null ) {
            try {
               FileOutputStream fout = new FileOutputStream(file);
               byte[] buf = new byte[1024];
               int n;
               while ( (n=rin.read(buf,0,1024)) != -1 )
                  fout.write(buf,0,n);
               rin.close();
               fout.close();
            } catch ( IOException ioe ) {
               ioe.printStackTrace();
            }
         } else {
            System.err.println("Error: Could not get remote input Stream!");
         }

         /* =============== Debuged by H.Asakura KGT inc. 2002/07/17 
         if ( !file.exists() ) {
            if ( rin != null ) {
               try {
                  FileOutputStream fout = new FileOutputStream(file);
                  byte[] buf = new byte[1024];
                  int n;
                  while ( (n=rin.read(buf,0,1024)) != -1 )
                     fout.write(buf,0,n);
                  rin.close();
                  fout.close();
               } catch ( IOException ioe ) {
                  ioe.printStackTrace();
               }
            } else {
               System.err.println("Error: Could not get remote input Stream!");
            }
         }
         */

         int index = work_path.lastIndexOf(sp);
         String avs_output_path = work_path.substring(work_path.lastIndexOf(sp), work_path.length()); 
         avs_output_path = avs_output_path + sp + ((Integer)hm.get("cmd.jobid")).toString() + sp + avs_output_file_name;
	 hm.put("avs.output.path", avs_output_path);
	 hm.put("avs.job.status", new Integer("2"));
         data.getResponse().setHeader("Refresh", "0;URL=viz303");
         data.setHeader("Expires","-1");
      } else {
	 if (statmsg.equals("ABORTED")) {
            // @==Error 
	    hm.put("avs.jobid", new Integer(jobid));
	    hm.put("avs.job.status", new Integer(-1));
	    setSessionParam();
	 } else {
	    refresh_interval = ((Integer)hm.get("system.page.refresh.interval")).intValue();
	    retry            = ((Integer)hm.get("system.num.pooling")).intValue();
	    max_retry        = ((Integer)hm.get("system.max.pooling")).intValue();

            if (retry >= max_retry) {
               // @==Retry Over 
	       hm.put("avs.job.status", new Integer(-1));
	       hm.put("system.num.pooling", new Integer(0));
	       setSessionParam();
	    } else {
               // @==Retry
	       retry++;
	       hm.put("avs.job.status", new Integer(1));
	       hm.put("system.num.pooling", new Integer(retry));
	       setSessionParam();
               data.getResponse().setHeader("Refresh", Integer.toString(refresh_interval)+";URL=viz303");
	    }
         }
      }
   }

    /** Viz303ڡ */
    protected void putPageParam_Exec() {
       OutputPageParam viz303 = new OutputPageParam();
       viz303.set("avs.job.status", hm.get("avs.job.status"));
       context.put("viz303", viz303);
       data.getResponse().setHeader("Refresh", Integer.toString(refresh_interval)+";URL=viz303");
    }
    protected void putPageParam_Check() {
       OutputPageParam viz303 = new OutputPageParam();
       viz303.set("avs.job.status", hm.get("avs.job.status"));
       context.put("viz303", viz303);
    }
    protected void putPageParam_View() {
       OutputPageParam viz303 = new OutputPageParam();
       viz303.set("avs.job.status", hm.get("avs.job.status"));
       viz303.set("cmd.jobid", hm.get("cmd.jobid"));
       viz303.set("avs.output.path", hm.get("avs.output.path"));
       context.put("viz303", viz303);
    }
}
